<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\ItempopenerimaanModel;
use App\Http\Models\PenerimaanbarangModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
use Carbon\Carbon;

class ItempopenerimaanService extends BaseService
{
	/**
     ItempopenerimaanService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new ItempopenerimaanModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->joinRelationItemId()->getQuery()->select([
			"itempopenerimaan.quantity as quantity",
			"itempopenerimaan.lotNumber",
			"itempopenerimaan.receiptDate as tglMasuk",
			"itempopenerimaan.qtyRemaining as jumlah",
			"itemId.id as id",
			"itemId.namaItem as namaItem",
			"itemId.part_number as part_number",
			"itemId.deskripsi as deskripsi",
			"itemId.category as category",
			"itemId.image as image",
			"itemId.item_price as harga",
			"itemId.UOM as UOM"
		])
			->where("itemId.enabled_flex", "=", "Y")
			->whereIn("itemId.type_id", $auth->arrCategory)
			->where("itempopenerimaan.qtyRemaining", ">", 0)
			->where("itempopenerimaan.status", "=", 0);
		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("itemId.kapalId", "=", $auth->kapalId);
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	public function store($input)
	{
		if (isset($input["itemID"]) && !empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			// var_dump($input);
			// var_dump($newInput); dd();
			if (!empty($newInput)) {
				// $this->model->fill($newInput);
				/* if(! $this->model->insert($newInput)) {
					throw new \Exception();
				} */
				foreach ($newInput as $row) {
					$itemBrg = new ItempopenerimaanModel();
					$itemBrg->fill($row);
					if (!$itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}

	private function getPrepare($input)
	{
		$data = [];
		if (isset($input["itemID"]) && !empty($input["itemID"])) {
			foreach ($input["itemID"] as $idx => $value) {
				$data[] = [
					"prNumber" => $input["prNumber"],
					"itemId" => $value,
					"needBy" => $input["needBy"][$value],
					"quantity" => $input["quantity"][$value]
				];
			}
		}
		return $data;
	}

	// DIPAKE DI ADJUSMENT MODEL, PENERIMAAN BARANG CONTROLLER
	public function updateQtyRemaining($input)
	{
		if (isset($input["itemID"]) && !empty($input["itemID"])) {
			foreach ($input["itemID"] as $itemID) {
				$itemPO = ItempopenerimaanModel::where("poNumber", $input["poNumber"])->where("itemId", $itemID);
				$itemPO = $itemPO->first();
				if ($itemPO) {
					if ($itemPO->qtyRemaining < $input["quantity"][$itemID]) {
						throw new \Exception('Item quantity received is not valid.');
					} else {
						$itemPO->qtyRemaining = $itemPO->qtyRemaining - $input["quantity"][$itemID];
						$itemPO->date_updated = Carbon::now()->toDateTimeString();
						if ($itemPO->qtyRemaining < 1) {
							$itemPO->status = 1;
							$itemPO->qtyRemaining = 0;
						} else {
							$itemPO->status = 0;
						}
					}

					if (!$itemPO->save()) {
						throw new \Exception();
					}
				}
			}
		}
	}

	public function getStatusItems($poNumber)
	{
		$nOpen = $this->model->getQuery()->selectRaw('COUNT("itempopenerimaan"."id") as "nStatus"')
			->where("status", "=", 0)
			->where("poNumber", "=", $poNumber)
			->first();

		return $nOpen->nStatus;
	}

	public function showBasedOnPoNumber($request, $headerTransaction)
	{
		$input = $request->all();
		// $auth = json_decode($request->session()->get('auth'));
		$model = $this->model->joinRelationItemId("itemId")->getQuery()
			->where("itempopenerimaan.poNumber", "=", $headerTransaction->poNumber)
			// ->where("itemId.kapalId", "=", $headerTransaction->kapalId)
			// ->whereIn("itemId.type_id", $auth->arrCategory)
			// ->whereIn("itempopenerimaan.lokasiId", $auth->arrLokasi)
			->select([
				"itempopenerimaan.id as id",
				"itempopenerimaan.poNumber",
				"itempopenerimaan.itemId",
				"itemId.namaItem as namaItem",
				"itemId.part_number as partNumber",
				"itemId.deskripsi as deskripsi",
				"itemId.category as category",
				"itemId.UOM as UOM",
				"itempopenerimaan.quantity",
				"itempopenerimaan.qtyRemaining",
				"itempopenerimaan.lokasiId as lokasiId",
				"itempopenerimaan.lotNumber as lotNumber"
			])
			->get();
		foreach ($model as $idx => $row) {
			$items = (new PenerimaanbarangModel())->joinRelationItemPenerimaanBarangId()->getQuery()
				->select(["itempenerimaanbarang.quantity", "itempenerimaanbarang.lotNumber"])
				->where("penerimaanbarang.poNumber", "=", $row->poNumber)
				->where("itempenerimaanbarang.itemId", "=", $row->itemId)
				->get();
			$qtyPenerimaan = 0;
			foreach ($items as $item) {
				$model[$idx]->qtyPenerimaans[] = [$item->quantity, $item->lotNumber];
				$qtyPenerimaan += $item->quantity;
			}
			$model[$idx]->qtyPenerimaan = $qtyPenerimaan;
		}

		if (isset($input["update"])) {
			foreach ($model as $idx => $row) {
				$differ = $row->quantity - $row->qtyPenerimaan;
				if ($row->qtyRemaining != $differ) {
					$model = ItempopenerimaanModel::find($row->id);
					$model->qtyRemaining = $differ;
					$model->update();
				}
			}
		}
		return $model;
	}
}
